/** @param {jQuery} $ jQuery Object */
!function($, window, document, _undefined)
{
	XenForo.ExtendedPoll_CustomFieldNew = function($element) { this.__construct($element); };
	XenForo.ExtendedPoll_CustomFieldNew.prototype =
	{
		__construct: function($element)
		{
			$element.find('.ExtendedPoll_CustomFieldName').one('change', $.context(this, 'createChoice'));

			this.$element = $element;
			if (!this.$base)
			{
				this.$base = $element.clone();
			}
		},

		createChoice: function()
		{
			var $new = this.$base.clone(),
				nextCounter = this.$element.parent().children().length;

			$new.find('input[name], select[name]').each(function()
			{
				var $this = $(this);
				$this.attr('name', $this.attr('name').replace(/\[(\d+)\]/, '[' + nextCounter + ']'));
			});

			$new.find('*[id]').each(function()
			{
				var $this = $(this);
				$this.removeAttr('id');
				XenForo.uniqueId($this);

				if (XenForo.formCtrl)
				{
					XenForo.formCtrl.clean($this);
				}
			});

			$new.xfInsert('insertAfter', this.$element);

			this.__construct($new);
		}
	};

	// *********************************************************************
	
	XenForo.ExtendedPoll_CustomFieldName = function($select) { this.__construct($select); };
	XenForo.ExtendedPoll_CustomFieldName.prototype =
	{
		__construct: function($select)
		{
			this.$select = $select;
			this.$parent = $select.parent();
			this.$valueInput = this.$parent.find('.ExtendedPoll_CustomFieldValueText');
			this.$valueSelects = this.$parent.find('.ExtendedPoll_CustomFieldValueSelect');
			
			this.$select.change($.context(this, 'nameChanged'));
			this.$valueSelects.change($.context(this, 'valueChanged'));
			
			this.nameChanged();
		},
		
		nameChanged: function()
		{
			var newName = this.$select.val(),
				$newValueSelect = this.$parent.find('.ExtendedPoll_CustomFieldValueSelect-' + newName)
				;
			
			if ($newValueSelect.length > 0)
			{
				// this custom field has the select type
				// display the <select /> and hide the default <input />
				this.$valueSelects.hide();
				this.$valueInput.hide();
				$newValueSelect.show().val(this.$valueInput.val());
			}
			else
			{
				this.$valueSelects.hide();
				this.$valueInput.show();
			}
			
			console.log(newName, $newValueSelect);
		},
		
		valueChanged: function(e)
		{
			var newValue = $(e.target).val();
			
			// update the <input /> with the new select value
			this.$valueInput.val(newValue);
		}
	};

	// *********************************************************************
	
	XenForo.ExtendedPoll_Injector = function($root) {
		var $elements = $root.children(),
			$targets = $($root.data('targets'));
		
		if ($elements.length == $targets.length)
		{
			for (var i = 0, l = $elements.length; i < l; i++)
			{
				var $element = $elements.eq(i),
					$target = $targets.eq(i);
				
				$element.xfInsert('appendTo', $target, 'xfFadeIn', 0);
			}
		}
	};
	
	// *********************************************************************

	XenForo.register('li.ExtendedPoll_CustomFieldNew', 'XenForo.ExtendedPoll_CustomFieldNew');
	XenForo.register('select.ExtendedPoll_CustomFieldName', 'XenForo.ExtendedPoll_CustomFieldName');
	XenForo.register('.ExtendedPoll_Injector', 'XenForo.ExtendedPoll_Injector');

}
(jQuery, this, document);