<?php

class ExtendedPoll_Extend_ControllerPublic_Thread extends XFCP_ExtendedPoll_Extend_ControllerPublic_Thread
{
	public function actionIndex()
	{
		$result = parent::actionIndex();

		if ($result instanceof XenForo_ControllerResponse_View)
		{
			/* @var $view XenForo_ControllerResponse_View */
			$view = &$result;

			$view->params['pollModel'] = $this->_getPollModel();
		}

		return $result;
	}

	public function actionShowPosts()
	{
		$result = parent::actionShowPosts();

		if ($result instanceof XenForo_ControllerResponse_View)
		{
			$this->ExtendedPoll_getPoll($result);
		}

		return $result;
	}

	public function actionAddReply()
	{
		$result = parent::actionAddReply();

		if ($result instanceof XenForo_ControllerResponse_View)
		{
			$this->ExtendedPoll_getPoll($result);
		}

		return $result;
	}

	public function actionPollEdit()
	{
		ExtendedPoll_Listener::$controller = $this;

		$result = parent::actionPollEdit();

		if ($result instanceof XenForo_ControllerResponse_View)
		{
			$result->params['ExtendedPoll_customFields'] = $this->getModelFromCache('XenForo_Model_Poll')->ExtendedPoll_getAvailableCustomFields();
		}

		return $result;
	}

	public function actionWithPolLDataWriter(XenForo_DataWriter_Poll $dw)
	{
		$options = $this->_input->filterSingle('extendedpoll_options', XenForo_Input::ARRAY_SIMPLE);
		$dw->set('extendedpoll_options', $options);
	}

	protected function ExtendedPoll_getPoll(XenForo_ControllerResponse_View &$view)
	{
		$thread = &$view->params['thread'];
		$forum = &$view->params['forum'];
		// the below code is copied from actionIndex()
		if ($thread['discussion_type'] == 'poll')
		{
			$threadModel = $this->_getThreadModel();
			$pollModel = $this->_getPollModel();
			$poll = $pollModel->getPollByContent('thread', $thread['thread_id']);
			if ($poll)
			{
				$poll = $pollModel->preparePoll($poll, $threadModel->canVoteOnPoll($thread, $forum));
				$poll['canEdit'] = $threadModel->canEditPoll($thread, $forum);
			}
		}
		else
		{
			$poll = false;
		}

		$view->params['poll'] = $poll;
		$view->params['pollModel'] = $this->_getPollModel();
	}

}
