<?php

class ExtendedPoll_Extend_Model_Thread extends XFCP_ExtendedPoll_Extend_Model_Thread
{
	protected $_autoFetchPoll = false;

	public function ExtendedPoll_startFetchingPoll()
	{
		$this->_autoFetchPoll = true;
	}

	public function ExtendedPoll_stopFetchingPoll()
	{
		$this->_autoFetchPoll = false;
	}

	public function prepareThreadFetchOptions(array $fetchOptions)
	{
		$result = parent::prepareThreadFetchOptions($fetchOptions);

		if ($this->_autoFetchPoll)
		{
			// injects our joins and selects
			$result['selectFields'] .= ', extendedpoll_poll.poll_id as extendedpoll_poll_id, extendedpoll_poll.responses as extendedpoll_poll_responses';
			$result['joinTables'] .= ' LEFT JOIN `xf_poll` AS extendedpoll_poll ON (extendedpoll_poll.content_type = \'thread\' AND extendedpoll_poll.content_id = thread.thread_id) ';
		}

		return $result;
	}

	public function getThreads(array $conditions, array $fetchOptions = array())
	{
		$result = parent::getThreads($conditions, $fetchOptions);

		if ($this->_autoFetchPoll)
		{
			// parses our fields
			foreach ($result as &$thread)
			{
				$responses = @unserialize($thread['extendedpoll_poll_responses']);
				if (empty($responses))
				{
					// this thread has no poll
					$thread['extendedpoll_poll_id'] = 0;
					$thread['extendedpoll_poll_responses'] = array();
					$thread['extendedpoll_poll_hasVoted'] = false;
				}
				else
				{
					// this thread has a poll
					$thread['extendedpoll_poll_id'] = intval($thread['extendedpoll_poll_id']);
					$thread['extendedpoll_poll_responses'] = $responses;
					$thread['extendedpoll_poll_hasVoted'] = false;

					// checks for voted flag
					if (!empty($fetchOptions['readUserId']))
					{
						// only do check if readUserId is set, and it's not empty (not guest)
						foreach ($responses as $response)
						{
							if (!empty($response['voters']))
							{
								// only do check this response if voters array is ready
								if (isset($response['voters'][$fetchOptions['readUserId']]))
								{
									// sets the flag because we found the vote
									$thread['extendedpoll_poll_hasVoted'] = true;
								}
							}
						}
					}
				}
			}
		}

		return $result;
	}

}
