<?php
class ExtendedPoll_Installer
{
	/* Start auto-generated lines of code. Change made will be overwriten... */

	protected static $_tables = array();
	protected static $_patches = array( array(
			'table' => 'xf_poll',
			'field' => 'extendedpoll_options',
			'showTablesQuery' => 'SHOW TABLES LIKE \'xf_poll\'',
			'showColumnsQuery' => 'SHOW COLUMNS FROM `xf_poll` LIKE \'extendedpoll_options\'',
			'alterTableAddColumnQuery' => 'ALTER TABLE `xf_poll` ADD COLUMN `extendedpoll_options` MEDIUMBLOB',
			'alterTableDropColumnQuery' => 'ALTER TABLE `xf_poll` DROP COLUMN `extendedpoll_options`',
		), );

	public static function install($existingAddOn, $addOnData)
	{
		$db = XenForo_Application::get('db');

		foreach (self::$_tables as $table)
		{
			$db->query($table['createQuery']);
		}

		foreach (self::$_patches as $patch)
		{
			$tableExisted = $db->fetchOne($patch['showTablesQuery']);
			if (empty($tableExisted))
			{
				continue;
			}

			$existed = $db->fetchOne($patch['showColumnsQuery']);
			if (empty($existed))
			{
				$db->query($patch['alterTableAddColumnQuery']);
			}
		}

		self::installCustomized($existingAddOn, $addOnData);
	}

	public static function uninstall()
	{
		$db = XenForo_Application::get('db');

		foreach (self::$_patches as $patch)
		{
			$tableExisted = $db->fetchOne($patch['showTablesQuery']);
			if (empty($tableExisted))
			{
				continue;
			}

			$existed = $db->fetchOne($patch['showColumnsQuery']);
			if (!empty($existed))
			{
				$db->query($patch['alterTableDropColumnQuery']);
			}
		}

		foreach (self::$_tables as $table)
		{
			$db->query($table['dropQuery']);
		}

		self::uninstallCustomized();
	}

	/* End auto-generated lines of code. Feel free to make changes below */

	private static function installCustomized($existingAddOn, $addOnData)
	{
		$db = XenForo_Application::get('db');

		$db->query("REPLACE INTO `xf_content_type` (content_type, addon_id, fields) VALUES ('extendedpoll_thread', 'ExtendedPoll', '')");
		$db->query("REPLACE INTO `xf_content_type_field` (content_type, field_name, field_value) VALUES ('extendedpoll_thread', 'news_feed_handler_class', 'ExtendedPoll_NewsFeedHandler_Thread')");
		XenForo_Model::create('XenForo_Model_ContentType')->rebuildContentTypeCache();
	}

	private static function uninstallCustomized()
	{
		// customized uninstall script goes here
	}

}
