<?php

class ExtendedPoll_Listener
{
	/* @var $controller XenForo_ControllerPublic_Abstract */
	public static $controller = NULL;

	public static function load_class($class, array &$extend)
	{
		static $classes = array(
			'XenForo_ControllerPublic_Forum',
			'XenForo_ControllerPublic_Thread',
			'XenForo_DataWriter_Poll',
			'XenForo_Model_Poll',
			'XenForo_Model_Thread',
			'XenForo_ViewPublic_Forum_View',
			'XenForo_ViewPublic_Thread_View',
			'XenForo_ViewPublic_Thread_ViewNewPosts',
			'XenForo_ViewPublic_Thread_ViewPosts',
		);

		if (in_array($class, $classes))
		{
			$extend[] = str_replace('XenForo_', 'ExtendedPoll_Extend_', $class);
		}
	}

	public static function template_create($templateName, array &$params, XenForo_Template_Abstract $template)
	{
		if ($templateName == 'thread_view')
		{
			$template->preloadTemplate('extendedpoll_message_content');
			$template->preloadTemplate('extendedpoll_thread_poll_results');
		}
		elseif ($templateName == 'thread_poll_results')
		{
			$template->preloadTemplate('extendedpoll_thread_poll_results');
		}
		elseif ($templateName == 'thread_create' OR $templateName == 'thread_poll_edit')
		{
			$template->preloadTemplate('extendedpoll_thread_poll_edit');
		}
	}

	public static function template_post_render($templateName, &$content, array &$containerData, XenForo_Template_Abstract $template)
	{
		if ($templateName == 'thread_view' OR $templateName == 'thread_poll_results')
		{
			$ourTemplate = $template->create('extendedpoll_thread_poll_results', $template->getParams());
			$rendered = $ourTemplate->render();

			self::inject($rendered, $content);
		}
		elseif ($templateName == 'thread_poll_edit')
		{
			$ourTemplate = $template->create('extendedpoll_thread_poll_edit', $template->getParams());
			$rendered = $ourTemplate->render();

			self::inject($rendered, $content);
		}
	}

	public static function template_hook($hookName, &$contents, array $hookParams, XenForo_Template_Abstract $template)
	{
		if ($hookName == 'message_content')
		{
			$ourTemplate = $template->create('extendedpoll_message_content', $hookParams);
			$rendered = $ourTemplate->render();

			self::inject($rendered, $contents);
		}
		elseif ($hookName == 'thread_create')
		{
			$ourTemplate = $template->create('extendedpoll_thread_poll_edit', $template->getParams());
			$ourTemplate->setParam('ExtendedPoll_markerMode', 'thread_create_fields_extra');
			$rendered = $ourTemplate->render();

			self::inject($rendered, $contents);
		}
	}

	protected static function inject($rendered, &$html, $mark = '<!-- ExtendedPoll / mark -->')
	{
		$posStart = strpos($rendered, $mark);
		$posEnd = false;
		if ($posStart !== false)
		{
			$posEnd = strpos($rendered, $mark, $posStart + 1);
		}

		if ($posStart !== false AND $posEnd !== false)
		{
			// found the pattern to search (and replace)
			$search = trim(substr($rendered, $posStart + strlen($mark), $posEnd - $posStart - strlen($mark)));
			if (!empty($search))
			{
				// does the replace
				$html = str_replace($search, str_replace($mark, '', $rendered), $html);
			}
		}
	}

}
