<?php

class ExtendedPoll_Option
{
	public static function get($key)
	{
		return XenForo_Application::get('options')->get('ExtendedPoll_' . $key);
	}

	public static function renderCustomFields(XenForo_View $view, $fieldPrefix, array $preparedOption, $canEdit)
	{
		$choices = array();

		$pollModel = XenForo_Model::create('XenForo_Model_Poll');
		$customFields = $pollModel->ExtendedPoll_getAllCustomFields();

		foreach ($customFields as $customField)
		{
			$name = $customField['name'];
			$label = $customField['title'];

			$choices[] = array(
				'name' => htmlspecialchars($fieldPrefix . "[$preparedOption[option_id]][$name]"),
				'label' => $label,
				'selected' => in_array($name, $preparedOption['option_value'])
			);
		}

		$preparedOption['formatParams'] = $choices;

		return XenForo_ViewAdmin_Helper_Option::renderOptionTemplateInternal('option_list_option_checkbox', $view, $fieldPrefix, $preparedOption, $canEdit);
	}

	public static function validateCustomFields(array &$data, XenForo_DataWriter $dw, $fieldName)
	{
		$output = array();

		$pollModel = XenForo_Model::create('XenForo_Model_Poll');
		if (is_callable(array(
			$pollModel,
			'ExtendedPoll_getAllCustomFields'
		)))
		{
			$customFields = $pollModel->ExtendedPoll_getAllCustomFields();

			foreach ($data AS $name => $value)
			{
				if (!empty($value) AND isset($customFields[$name]))
				{
					$output[] = $name;
				}
			}

			$data = $output;
		}

		return true;
	}

}
